| Home | Libraries | People | FAQ | More

#### read (2 of 8 overloads)

Attempt to read a certain amount of data from a stream before returning.

    template<
        typename SyncReadStream,
        typename MutableBufferSequence>
    std::size_t read(
        SyncReadStream & s,
        const MutableBufferSequence & buffers,
        boost::system::error_code & ec);

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- The supplied buffers are full. That is, the bytes transferred is equal to the sum of the buffer sizes.
- An error occurred.

This operation is implemented in terms of zero or more calls to the stream's read_some function.

###### Parameters

s

  The stream from which the data is to be read. The type must support the SyncReadStream concept.

buffers

  One or more buffers into which the data will be read. The sum of the buffer sizes indicates the maximum number of bytes to read from the stream.

ec

  Set to indicate what error occurred, if any.

###### Return Value

The number of bytes transferred.

###### Example

To read into a single data buffer use the `buffer` function as follows:

    boost::asio::read(s, boost::asio::buffer(data, size), ec);

See the `buffer` documentation for information on reading into multiple buffers in one go, and how to use it with arrays, boost::array or std::vector.

###### Remarks

This overload is equivalent to calling:

    boost::asio::read(
        s, buffers,
        boost::asio::transfer_all(), ec);